<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="600">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="120px"
    >
      <el-form-item label="父类型" prop="parentTypeId" v-if="formData.parentTypeId !== 0">
        <el-tree-select
          v-model="formData.parentTypeId"
          :data="typeOptions"
          :props="{ value: 'id', label: 'lockTypeName', children: 'children' }"
          placeholder="选择父级"
        />
      </el-form-item>

      <el-form-item label="挂锁类型名称" prop="lockTypeName">
        <el-input v-model="formData.lockTypeName" placeholder="请输入挂锁类型名称" />
      </el-form-item>

      <!--      <el-row>-->
      <!--        <el-col :span="19">-->
      <!--          <el-form-item label="挂锁类型编码" prop="lockTypeCode">-->
      <!--            <el-input-->
      <!--              v-model="formData.lockTypeCode"-->
      <!--              placeholder="请输入挂锁类型编码"-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--        </el-col>-->
      <!--        <el-col :span="3">-->
      <!--          <el-form-item label-width="80">-->
      <!--            <el-switch-->
      <!--              v-model="autoGenFlag"-->
      <!--              active-text="自动生成"-->
      <!--              @change="handleAutoGenChange"-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--        </el-col>-->
      <!--      </el-row>-->

      <el-form-item label="挂锁型号" prop="lockTypeSpec">
        <el-input v-model="formData.lockTypeSpec" placeholder="请输入挂锁型号" />
      </el-form-item>

      <el-form-item label="挂锁类型图标" prop="lockTypeIcon">
        <UploadImg :limit="1" v-model="formData.lockTypeIcon" :fileSize="5" />
      </el-form-item>

      <el-form-item label="挂锁类型图片" prop="lockTypeImg">
        <UploadImg :limit="1" v-model="formData.lockTypeImg" :fileSize="5" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import { handleTree } from '@/utils/tree'
import * as padLockTypeApi from '@/api/hw/type/padLockType/index'
import * as HardwareTypeApi from '@/api/hw/type/hardwaretype/index'


// import { genCode } from '@/api/system/autocode/rule'

defineOptions({ name: 'LockTypeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  lockTypeId: undefined,
  parentTypeId: 0,
  hardwareTypeId: undefined,
  lockTypeName: '',
  lockTypeCode: '',
  lockTypeIcon: undefined,
  lockTypeImg: undefined,
  lockTypeSpec: undefined
})
const formRules = reactive({
  // lockTypeCode: [{ required: true, message: '挂锁类型编号不能为空', trigger: 'blur' }],
  lockTypeName: [{ required: true, message: '挂锁类型名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

// 类型树相关
const typeOptions = ref([])


// 硬件类型树相关
const hardwareTypeOptions = ref([])

// 自动生成编码
const autoGenFlag = ref(false)

/** 获取类型树 */
const getTypeTree = async () => {
  const res = await padLockTypeApi.listpadLockTypeApi({
    pageNo: 1,
    pageSize: -1
  })
  typeOptions.value = handleTree(res.list, 'id', 'parentTypeId')
}

/** 获取硬件类型树 */
const getHardwareTypeTree = async () => {
  const res = await HardwareTypeApi.listHardwareType({
    pageNo: 1,
    pageSize: -1
  })
  hardwareTypeOptions.value = handleTree(res.list, 'id', 'parentTypeId')
}

/** 打开弹窗 */
const open = async (type: string, id?: number,parentTypeId?:number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 设置父级ID
  if (parentTypeId) {
    formData.value.parentTypeId = parentTypeId
  }

  await Promise.all([getTypeTree(), getHardwareTypeTree()])
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await padLockTypeApi.getpadLockTypeInfoAPI(id)
      // if (formData.value.parentTypeId === 0) {
      //   formData.value.parentTypeId = undefined
      // }
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await padLockTypeApi.addpadLockTypeApi(data)
      message.success(t('common.createSuccess'))
    } else {
      await padLockTypeApi.updatepadLockTypeApi(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 自动生成编码 */
// const handleAutoGenChange = async (val: boolean) => {
//   if (val) {
//     const res = await genCode('LOCK_TYPE_CODE')
//     formData.value.lockTypeCode = res.data
//   } else {
//     formData.value.lockTypeCode = ''
//   }
// }

/** 图标上传成功 */
const handleIconUploaded = (imgUrl: any[]) => {
  formData.value.lockTypeIcon = imgUrl[0].url
}

/** 图标移除 */
const handleIconRemoved = () => {
  formData.value.lockTypeIcon = undefined
}

/** 图片上传成功 */
const handleImgUploaded = (imgUrl: any[]) => {
  formData.value.lockTypeImg = imgUrl[0].url
}

/** 图片移除 */
const handleImgRemoved = () => {
  formData.value.lockTypeImg = undefined
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    lockTypeId: undefined,
    parentTypeId: 0,
    hardwareTypeId: undefined,
    lockTypeName: '',
    lockTypeCode: '',
    lockTypeIcon: undefined,
    lockTypeImg: undefined,
    lockTypeSpec: undefined
  }
  formRef.value?.resetFields()
  autoGenFlag.value = false
}
</script>
